diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/matvecutils.h lsqrms-2.0.4b/src/matvecutils.h
--- lsqrms-2.0.4b.old/src/matvecutils.h
+++ lsqrms-2.0.4b/src/matvecutils.h	Sun Feb 24 22:49:50 EST 2008
@@ -0,0 +1,38 @@
+#include "lsqrms.h"
+#include <ctype.h>
+
+#ifndef _toupper
+# define _toupper(x) (toupper((x)))
+#endif
+#ifndef _tolower
+# define _tolower(x) (tolower((x)))
+#endif
+
+#define tohigh(x) ((x) | ~0177)
+
+typedef double rotate_t[3][3];
+typedef double xlate_t[3];
+typedef struct Coord { double x, y, z; } CoordType;
+
+double bestfit(rotate_t , xlate_t , CoordType *, CoordType *, const int );
+double rotrans(double **, int, rotate_t, xlate_t);
+int check_eq(int *, int *, int *, int *, int);
+double distrms(CoordType *a, CoordType *b, int npts);
+
+char convert321(char *, int, int);
+double blosum62(char, char, int, int);
+double nussinov(char, char, int, int);
+double gonnet_p(char, char, int, int);
+double glyproaln(char, char, int, int);
+double pam120_p(char, char, int, int);
+double check_carbonyl(char, char);
+
+double findCM(double **, int, double *);
+/* Below could actually be unified with rotrans - Allen */
+double TRmoveXYZstruc(double *,double **,double **, int);
+int FindMaxXYZDistIdxLast(double **, int);
+int FindMaxXYDistIdxLast(double **, int);
+double AlignZ(double, double, double, double *, double *);
+double FormRotMatrX(double **, double);
+double FormRotMatrY(double **, double);
+double FormRotMatrZ(double **, double);
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/provepdb.c lsqrms-2.0.4b/src/provepdb.c
--- lsqrms-2.0.4b.old/src/provepdb.c	Sun Apr 20 17:34:29 EDT 2003
+++ lsqrms-2.0.4b/src/provepdb.c	Sun Feb 24 22:49:49 EST 2008
@@ -1,13 +1,17 @@
-#include <stdlib.h>
-#include <stdio.h>
-#include <string.h>
+#include "lsqrms.h"
 
-char *provepdb (char *filename) {
-  FILE *file_stream = fopen (filename, "r");
+#if HAVE_MEMORY_H
+# include <memory.h>
+#endif
 
-  char *return_string = NULL;
+#include "provepdb.h"
+#include "matvecutils.h"
 
-  int i = 0;
+char *provepdb (char *filename, int altered, int use_carbonyl) {
+  FILE *file_stream;
+  char *return_string = NULL;
+  int i = 0, j = 0;
+  int saw_ter = 0;
   char c;
   char *line_read = NULL;
   int line_length = 0;
@@ -12,76 +16,219 @@
   char *line_read = NULL;
   int line_length = 0;
   int abc = 0;
-
   char *new_string = NULL;
-    
   char *chem = NULL;
+  char *which = NULL;
   double x, y, z;
-
   char *tempstr = NULL;
 
+  file_stream = fopen(filename, "r");
+
   if (file_stream == NULL)
     return NULL;
 
-  chem = malloc (sizeof (char) * 4);
-  tempstr = malloc (sizeof (char) * 9);
-  tempstr[8] = (char) NULL;
+  tempstr = malloc(sizeof (char) * 9);
+  if (!tempstr) {
+    printf("provepdb: Allocation failed!\n");
+    return NULL;
+  }
+  tempstr[8] = (char)NULL;
 
   do {
     abc++;
     do {
-      if ((fread (&c, sizeof (char), 1, file_stream) == 1) &&
-	  (!feof (file_stream))) {
-	line_read = 
-	  (char *) realloc (line_read, sizeof (char) * (line_length + 2));
+      if ((fread(&c, sizeof (char), 1, file_stream) == 1) &&
+	  (!feof(file_stream))) {
+	line_read = (char *)realloc(line_read, sizeof(char)*(line_length + 2));
 	line_read[line_length] = c;
 	line_read[line_length + 1] = (char) 0;
-	line_length = strlen (line_read);
-      }
-      else
+	line_length = strlen(line_read);
+      } else
 	break;
+    } while (c != (char) '\n');
+
+    if ((line_length >= 6) &&
+	(strncmp(line_read, "ENDMDL", 6) == 0))
+      break;
+
+    if (line_length >= 50) {
+      chem = malloc(sizeof (char) * 4);
+      if (!chem) {
+	printf("provepdb: Allocation failed!\n");
+	return NULL;
     }
-    while (c != (char) '\n');
-    if ((line_length >= 50) &&
-	(sscanf (line_read, "ATOM %*d CA %s", chem) == 1)) {
-      new_string = malloc (sizeof (char) * (strlen (line_read) + 1));
+      which = malloc(sizeof (char) * 2);
+      if (!chem) {
+	printf("provepdb: Allocation failed!\n");
+	return NULL;
+      }
+
+      if (sscanf(line_read, "ATOM %*d CA%*[ ] %3[^ ]%*[ ]",
+		 chem) == 1) {
+	new_string = malloc(sizeof(char) * (strlen(line_read) + 1));
+	if (!new_string) {
+	  fprintf(stderr,"provepdb: Allocation failed!\n");
+	  return NULL;
+	}
 
       i++;
+	j++;
       
       line_read[29] = '0';
       line_read[37] = '0';
       line_read[45] = '0';
-      tempstr = memcpy (tempstr, (char *) (line_read + 30), 8);
-      x = strtod (tempstr, NULL);
-      tempstr = memcpy (tempstr, (char *) (line_read + 38), 8);
-      y = strtod (tempstr, NULL);
-      tempstr = memcpy (tempstr, (char *) (line_read + 46), 8);
-      z = strtod (tempstr, NULL);
+	tempstr = memcpy(tempstr, (char *)(line_read + 30), 8);
+	x = strtod(tempstr, NULL);
+	tempstr = memcpy(tempstr, (char *)(line_read + 38), 8);
+	y = strtod(tempstr, NULL);
+	tempstr = memcpy(tempstr, (char *)(line_read + 46), 8);
+	z = strtod(tempstr, NULL);
       
-      sprintf (new_string, "ATOM%7d  CA%5s L%4d%12.3f%8.3f%8.3f\n",
-	       i, chem, i, x, y, z);
-      new_string = (char *) realloc (new_string, strlen (new_string) + 1);
+	sprintf(new_string,
+		"ATOM%7d  CA   %.3s %4d %12.3f %8.3f %8.3f\n",
+		i, chem, j, x, y, z);
+	new_string = (char *)realloc(new_string, strlen (new_string) + 1);
       if (return_string == NULL)
-	return_string = strdup ("");
+	  return_string = strdup("");
+	return_string = (char *)realloc(return_string,
+					sizeof(char)*(strlen(return_string) + 
+						      strlen(new_string) + 1));
+	return_string = strcat(return_string, new_string);
+	free(new_string);
+	new_string = NULL;
+      } else if ((!saw_ter) &&
+		 (sscanf(line_read, "HETATM%*d CA%*[ ] %3[^ ]%*[ ]",
+			 chem) == 1)) {
+	if (convert321(chem, 0, altered) != '?') {
+	  new_string = malloc(sizeof(char) * (strlen(line_read) + 1));
+	  if (!new_string) {
+	    fprintf(stderr,"provepdb: Allocation failed!\n");
+	    return NULL;
+	  }
+	  
+	  i++;
+	  j++;
+	  
+	  line_read[29] = '0';
+	  line_read[37] = '0';
+	  line_read[45] = '0';
+	  tempstr = memcpy(tempstr, (char *)(line_read + 30), 8);
+	  x = strtod(tempstr, NULL);
+	  tempstr = memcpy(tempstr, (char *)(line_read + 38), 8);
+	  y = strtod(tempstr, NULL);
+	  tempstr = memcpy(tempstr, (char *)(line_read + 46), 8);
+	  z = strtod(tempstr, NULL);
+
+	  sprintf(new_string,
+		  "ATOM%7d  CA   %.3s %4d %12.3f %8.3f %8.3f\n",
+		  i, chem, j, x, y, z);
+	  new_string = (char *)realloc(new_string, strlen (new_string) + 1);
+	  if (return_string == NULL)
+	    return_string = strdup("");
       return_string = 
-	(char *) realloc (return_string, 
-			  sizeof (char) * (strlen (return_string) + 
-					   strlen (new_string) + 1));
-      return_string = strcat (return_string, new_string);
-      free (new_string);
+	    (char *)realloc(return_string,
+			    sizeof(char)*(strlen(return_string) + 
+					  strlen(new_string) + 1));
+	  return_string = strcat(return_string, new_string);
+	  free(new_string);
       new_string = NULL;
+	}
+      } else if (use_carbonyl &&
+		 (sscanf(line_read, "ATOM %*d %[OCN]%*[ ] %3[^ ]%*[ ]",
+			 which, chem) == 2)) {
+	new_string = malloc(sizeof(char) * (strlen(line_read) + 1));
+	if (!new_string) {
+	  fprintf(stderr,"provepdb: Allocation failed!\n");
+	  return NULL;
+	}
       
-      if (strncmp (line_read, "ENDMDL", 6) == 0)
-	break;
+	i++;
+	
+	line_read[29] = '0';
+	line_read[37] = '0';
+	line_read[45] = '0';
+	tempstr = memcpy(tempstr, (char *)(line_read + 30), 8);
+	x = strtod(tempstr, NULL);
+	tempstr = memcpy(tempstr, (char *)(line_read + 38), 8);
+	y = strtod(tempstr, NULL);
+	tempstr = memcpy(tempstr, (char *)(line_read + 46), 8);
+	z = strtod(tempstr, NULL);
+
+	if (which[0] == 'N')
+	  sprintf(new_string,
+		"ATOM%7d  %s    %.3s %4d %12.3f %8.3f %8.3f\n",
+		i, which, chem, j+1, x, y, z);
+	else
+	  sprintf(new_string,
+		  "ATOM%7d  %s    %.3s %4d %12.3f %8.3f %8.3f\n",
+		  i, which, chem, j, x, y, z);
+	new_string = (char *)realloc(new_string, strlen (new_string) + 1);
+	if (return_string == NULL)
+	  return_string = strdup("");
+	return_string = (char *)realloc(return_string,
+					sizeof(char)*(strlen(return_string) + 
+						      strlen(new_string) + 1));
+	return_string = strcat(return_string, new_string);
+	free(new_string);
+	new_string = NULL;
+      } else if (use_carbonyl && (! saw_ter) &&
+		 (sscanf(line_read, "HETATM%*d %[OCN]%*[ ] %3[^ ]%*[ ]",
+			 which, chem)
+		  == 2)) {
+	if (convert321(chem, 0, altered) != '?') {
+	  new_string = malloc(sizeof(char) * (strlen(line_read) + 1));
+	  if (!new_string) {
+	    fprintf(stderr,"provepdb: Allocation failed!\n");
+	    return NULL;
     }
-    free (line_read);
+	  
+	  i++;
+	  
+	  line_read[29] = '0';
+	  line_read[37] = '0';
+	  line_read[45] = '0';
+	  tempstr = memcpy(tempstr, (char *)(line_read + 30), 8);
+	  x = strtod(tempstr, NULL);
+	  tempstr = memcpy(tempstr, (char *)(line_read + 38), 8);
+	  y = strtod(tempstr, NULL);
+	  tempstr = memcpy(tempstr, (char *)(line_read + 46), 8);
+	  z = strtod(tempstr, NULL);
+	  
+	  if (which[0] == 'N')
+	    sprintf(new_string,
+		    "ATOM%7d  %s    %.3s %4d %12.3f %8.3f %8.3f\n",
+		    i, which, chem, j+1, x, y, z);
+	  else
+	    sprintf(new_string,
+		    "ATOM%7d  %s    %.3s %4d %12.3f %8.3f %8.3f\n",
+		    i, which, chem, j, x, y, z);
+	  new_string = (char *)realloc(new_string, strlen (new_string) + 1);
+	  if (return_string == NULL)
+	    return_string = strdup("");
+	  return_string =
+	    (char *)realloc(return_string,
+			    sizeof(char)*(strlen(return_string) + 
+					  strlen(new_string) + 1));
+	  return_string = strcat(return_string, new_string);
+	  free(new_string);
+	  new_string = NULL;
+	}
+      }
+      free(chem);
+    }
+    if ((!saw_ter) && (line_length >= 3) &&
+	(strncmp(line_read, "TER", 3) == 0))
+      saw_ter = 1;
+
+    free(line_read);
     line_read = NULL;
     line_length = 0;
-    if (feof (file_stream))
+
+    if (feof(file_stream))
       break;
-  }
-  while (1);
-  fclose (file_stream);
+  } while (1);
+
+  fclose(file_stream);
   file_stream = NULL;
   return return_string;
 }
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/provepdb.h lsqrms-2.0.4b/src/provepdb.h
--- lsqrms-2.0.4b.old/src/provepdb.h	Wed Apr 16 15:06:10 EDT 2003
+++ lsqrms-2.0.4b/src/provepdb.h	Sun Feb 24 22:49:49 EST 2008
@@ -1,6 +1,6 @@
 #ifndef PROVEPDB_H
 #define PROVEPDB_H
 
-char *provepdb (char *filename);
+char *provepdb (char *filename, int altered, int use_carbonyl);
 
 #endif
diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/umath.h lsqrms-2.0.4b/src/umath.h
--- lsqrms-2.0.4b.old/src/umath.h	Wed Mar 12 17:12:18 EST 2003
+++ lsqrms-2.0.4b/src/umath.h	Sun Feb 24 22:49:49 EST 2008
@@ -1,5 +1,34 @@
-#define FABS(a) ((a) > 0 ? (a) : (-a))
-#define SQRTABS(a) ((a) > 0 ? sqrt(a) : sqrt(-a))
+#ifndef UMATH_H
+#define UMATH_H
+
+#include "lsqrms.h"
+
+#include <math.h>
+
+#if STDC_HEADERS
+# include <float.h>
+#endif
+
+#define FABS(a) ((a) >= 0 ? (a) : (-a))
+#define SQRTABS(a) ((a) >= 0 ? sqrt(a) : sqrt(-a))
+
+#if defined(__EXTENSIONS__) && defined(_MIPS_FPSET) && (_MIPS_FPSET >= 32)
+#  define LDBL long double
+#  define DSQRTABS(a) ((a) >= 0 ? sqrtl(a) : sqrtl(-a))
+#  define DSQRT(a) sqrtl(a)
+#  define DSIN(a) sinl(a)
+#  define DCOS(a) cosl(a)
+#  define DACOS(a) acosl(a)
+#  define DATAN(a) atanl(a)
+#else
+#  define LDBL double
+#  define DSQRTABS(a) ((a) >= 0 ? sqrt(a) : sqrt(-a))
+#  define DSQRT(a) sqrt(a)
+#  define DSIN(a) sin(a)
+#  define DCOS(a) cos(a)
+#  define DACOS(a) acos(a)
+#  define DATAN(a) atan(a)
+#endif
 
 #ifndef __sgi
 #  define fsqrt(a) sqrt(a)
@@ -6,7 +35,7 @@
 #endif
 
 #define SQR(a) ((a)*(a))
-#define DSQR(a) ((double)(a)*(double)(a))
+#define DSQR(a) ((LDBL)(a)*(LDBL)(a))
 #define CUBE(a) ((a)*(a)*(a))
 
 #ifndef MIN
@@ -13,3 +42,15 @@
 #  define MIN(a,b) (((a)<(b))?(a):(b))
 #  define MAX(a,b) (((a)>(b))?(a):(b))
 #endif
+
+#ifdef DBL_EPSILON
+# define epsilon DBL_EPSILON
+#else
+# ifdef __STDC__
+#  define epsilon 1e-9
+# else
+#  define epsilon 1e-7
+# endif
+#endif
+
+#endif /* ! defined(UMATH_H) */
